using pdftron; 
using pdftron.Common; 
using pdftron.Filters; 
using pdftron.SDF; 
using pdftron.PDF; 

namespace AnnotationTestCS
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
        private static pdftron.PDFNetLoader pdfNetLoader = pdftron.PDFNetLoader.Instance();

        static void EmbedFlash(PDFDoc doc) 
        {
            string input_path = "../../../../TestFiles/";

            pdftron.PDF.Annot a = Annot.Create(doc, Annot.Type.e_RichMedia, new Rect(12, 632, 604, 771)); 
            Obj dict = a.GetSDFObj(); 

            Obj  mc = dict.PutDict("RichMediaContent"); 

            // Embed the flash file. 
            string flash_file = "header.swf";
            FileSpec fs = FileSpec.Create(doc, input_path + flash_file, true); 

            fs.GetSDFObj().PutString("F", flash_file);  // Not sure if this is right for non-ascii file paths. Hopefuly in this case UF should be taken as authority. 
            fs.GetSDFObj().PutText("UF", flash_file); 


            // Create/find the asset NameTree. 
            NameTree assets = pdftron.SDF.NameTree.Create(doc, "Assets"); 
            assets.Put(System.Text.Encoding.UTF8.GetBytes("header.swf"), fs.GetSDFObj()); 

            mc.Put("Assets", assets.GetSDFObj()); 

            Obj config = doc.CreateIndirectDict(); 
            config.PutName("Subtype", "Flash"); 

            Obj instance = doc.CreateIndirectDict(); 
            instance.Put("Asset", fs.GetSDFObj()); 
            instance.PutDict("Params").PutName("Binding", "Background"); 

            Obj instances = doc.CreateIndirectArray(); 
            instances.PushBack(instance); 
            config.Put("Instances", instances); 

            Obj configs = doc.CreateIndirectArray(); 
            configs.PushBack(config); 

            mc.Put("Configurations", configs); 

            // Optional: Fill-in RichMediaSettings dictionary 
            // Obj  ms = dict.PutDict("RichMediaSettings"); 

            //... 
            // add annotation to the page. 
            Page page = doc.GetPage(1); 
            page.AnnotPushBack(a); 
        }

        static void Main(string[] args)
        {
            PDFNet.Initialize();
            try
            {
                using (PDFDoc doc = new PDFDoc("../../../../TestFiles/numbered.pdf"))
                {
                    doc.InitSecurityHandler();
                    EmbedFlash(doc);
                    doc.Save("../../../../TestFiles/Output/our.pdf", SDFDoc.SaveOptions.e_linearized);
                }
            }
            catch (PDFNetException e)
            {
                System.Console.WriteLine(e.Message);
            }
        } 

	}
}
